package com.rebusland.fin.derivatives.eq.server.http.request.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import com.rebusland.fin.derivatives.eq.server.input.model.Derivative;
import com.rebusland.fin.derivatives.eq.server.input.model.FlatMarketData;
import com.rebusland.fin.derivatives.eq.server.input.model.MonteCarloSettings;
import java.util.Map;
import java.util.NoSuchElementException;

import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class PricingRequest extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final Long id;

	@PropertyDefinition(validate = "notNull")
	private final Derivative product;

	@PropertyDefinition(validate = "notNull")
	private final FlatMarketData mktData;

	@PropertyDefinition(validate = "notNull")
	private final MonteCarloSettings monteCarloSettings;
	
	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code PricingRequest}.
	 * @return the meta-bean, not null
	 */
	public static PricingRequest.Meta meta() {
		return PricingRequest.Meta.INSTANCE;
	}

	static {
		MetaBean.register(PricingRequest.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static PricingRequest.Builder builder() {
		return new PricingRequest.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected PricingRequest(PricingRequest.Builder builder) {
		JodaBeanUtils.notNull(builder.id, "id");
		JodaBeanUtils.notNull(builder.product, "product");
		JodaBeanUtils.notNull(builder.mktData, "mktData");
		JodaBeanUtils.notNull(builder.monteCarloSettings, "monteCarloSettings");
		this.id = builder.id;
		this.product = builder.product;
		this.mktData = builder.mktData;
		this.monteCarloSettings = builder.monteCarloSettings;
	}

	@Override
	public PricingRequest.Meta metaBean() {
		return PricingRequest.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the id.
	 * @return the value of the property, not null
	 */
	public Long getId() {
		return id;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the product.
	 * @return the value of the property, not null
	 */
	public Derivative getProduct() {
		return product;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the mktData.
	 * @return the value of the property, not null
	 */
	public FlatMarketData getMktData() {
		return mktData;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the monteCarloSettings.
	 * @return the value of the property, not null
	 */
	public MonteCarloSettings getMonteCarloSettings() {
		return monteCarloSettings;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			PricingRequest other = (PricingRequest) obj;
			return JodaBeanUtils.equal(id, other.id) &&
					JodaBeanUtils.equal(product, other.product) &&
					JodaBeanUtils.equal(mktData, other.mktData) &&
					JodaBeanUtils.equal(monteCarloSettings, other.monteCarloSettings);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(id);
		hash = hash * 31 + JodaBeanUtils.hashCode(product);
		hash = hash * 31 + JodaBeanUtils.hashCode(mktData);
		hash = hash * 31 + JodaBeanUtils.hashCode(monteCarloSettings);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(160);
		buf.append("PricingRequest{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("id").append('=').append(JodaBeanUtils.toString(id)).append(',').append(' ');
		buf.append("product").append('=').append(JodaBeanUtils.toString(product)).append(',').append(' ');
		buf.append("mktData").append('=').append(JodaBeanUtils.toString(mktData)).append(',').append(' ');
		buf.append("monteCarloSettings").append('=').append(JodaBeanUtils.toString(monteCarloSettings)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code PricingRequest}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code id} property.
		 */
		private final MetaProperty<Long> id = DirectMetaProperty.ofImmutable(
				this, "id", PricingRequest.class, Long.class);
		/**
		 * The meta-property for the {@code product} property.
		 */
		private final MetaProperty<Derivative> product = DirectMetaProperty.ofImmutable(
				this, "product", PricingRequest.class, Derivative.class);
		/**
		 * The meta-property for the {@code mktData} property.
		 */
		private final MetaProperty<FlatMarketData> mktData = DirectMetaProperty.ofImmutable(
				this, "mktData", PricingRequest.class, FlatMarketData.class);
		/**
		 * The meta-property for the {@code monteCarloSettings} property.
		 */
		private final MetaProperty<MonteCarloSettings> monteCarloSettings = DirectMetaProperty.ofImmutable(
				this, "monteCarloSettings", PricingRequest.class, MonteCarloSettings.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"id",
				"product",
				"mktData",
				"monteCarloSettings");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return id;
				case -309474065:  // product
					return product;
				case 1126223712:  // mktData
					return mktData;
				case -1026194915:  // monteCarloSettings
					return monteCarloSettings;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public PricingRequest.Builder builder() {
			return new PricingRequest.Builder();
		}

		@Override
		public Class<? extends PricingRequest> beanType() {
			return PricingRequest.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code id} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Long> id() {
			return id;
		}

		/**
		 * The meta-property for the {@code product} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Derivative> product() {
			return product;
		}

		/**
		 * The meta-property for the {@code mktData} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<FlatMarketData> mktData() {
			return mktData;
		}

		/**
		 * The meta-property for the {@code monteCarloSettings} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<MonteCarloSettings> monteCarloSettings() {
			return monteCarloSettings;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return ((PricingRequest) bean).getId();
				case -309474065:  // product
					return ((PricingRequest) bean).getProduct();
				case 1126223712:  // mktData
					return ((PricingRequest) bean).getMktData();
				case -1026194915:  // monteCarloSettings
					return ((PricingRequest) bean).getMonteCarloSettings();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code PricingRequest}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<PricingRequest> {

		private Long id;
		private Derivative product;
		private FlatMarketData mktData;
		private MonteCarloSettings monteCarloSettings;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(PricingRequest beanToCopy) {
			this.id = beanToCopy.getId();
			this.product = beanToCopy.getProduct();
			this.mktData = beanToCopy.getMktData();
			this.monteCarloSettings = beanToCopy.getMonteCarloSettings();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					return id;
				case -309474065:  // product
					return product;
				case 1126223712:  // mktData
					return mktData;
				case -1026194915:  // monteCarloSettings
					return monteCarloSettings;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 3355:  // id
					this.id = (Long) newValue;
					break;
				case -309474065:  // product
					this.product = (Derivative) newValue;
					break;
				case 1126223712:  // mktData
					this.mktData = (FlatMarketData) newValue;
					break;
				case -1026194915:  // monteCarloSettings
					this.monteCarloSettings = (MonteCarloSettings) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public PricingRequest build() {
			return new PricingRequest(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the id.
		 * @param id  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder id(Long id) {
			JodaBeanUtils.notNull(id, "id");
			this.id = id;
			return this;
		}

		/**
		 * Sets the product.
		 * @param product  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder product(Derivative product) {
			JodaBeanUtils.notNull(product, "product");
			this.product = product;
			return this;
		}

		/**
		 * Sets the mktData.
		 * @param mktData  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder mktData(FlatMarketData mktData) {
			JodaBeanUtils.notNull(mktData, "mktData");
			this.mktData = mktData;
			return this;
		}

		/**
		 * Sets the monteCarloSettings.
		 * @param monteCarloSettings  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder monteCarloSettings(MonteCarloSettings monteCarloSettings) {
			JodaBeanUtils.notNull(monteCarloSettings, "monteCarloSettings");
			this.monteCarloSettings = monteCarloSettings;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(160);
			buf.append("PricingRequest.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("id").append('=').append(JodaBeanUtils.toString(id)).append(',').append(' ');
			buf.append("product").append('=').append(JodaBeanUtils.toString(product)).append(',').append(' ');
			buf.append("mktData").append('=').append(JodaBeanUtils.toString(mktData)).append(',').append(' ');
			buf.append("monteCarloSettings").append('=').append(JodaBeanUtils.toString(monteCarloSettings)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
